function setVirusLabel(oldURI, msg, color) {
    if (gFolderDisplay.selectedCount == 0) return;
    var newURI = gFolderDisplay.selectedMessageUris[0];
    var statusLabel = document.getElementById('clamdrib-scanstatus');
    if(statusLabel) {
        statusLabel.value = msg;
        statusLabel.style.color = color;
    }
}

// function clamdStreamMsg(msgInStream, chost, strport) {
//     /* create a socket transport interface */
//     var transportSvc = Components.classes["@mozilla.org/network/socket-transport-service;1"];
//     if (!transportSvc) return false;
//     transportSvc = transportSvc.getService(Components.interfaces.nsISocketTransportService);
//     if (!transportSvc) return false;

//     dump("Attempting to connect to clamd at " + chost + ":" + strport + " for streaming...\n");
//     try {
// 	/* get the transport service */
// 	var clamdTrans = transportSvc.createTransport(null,0,chost,strport,null);
//     } catch (ex) {
// 	dump("falied to create transport: " + ex + "\n");
// 	return false;
//     }
//     if(!clamdTrans) return false;

//     /* where to write to */
//     var clamdOutStream = clamdTrans.openOutputStream(0,0,0);
//     if(!clamdOutStream) return false;

//     /* an observer needed to async close the output socket */
//     var observer = {
// 	onStartRequest: function(aRequest, aContext) {
// 	    dump("Streaming to clamd initiated...\n");
// 	},
// 	onStopRequest: function(aRequest, aContext, aStatusCode) {
// 	    dump("Streaming to clamd completed with " + aStatusCode + "\n");
// 	    if(!aStatusCode) clamdOutStream.close();
// 	    else return 0;
// 	}
//     };
	
//     /* a listener for the pump doing async writes each time the pump pumps data */
//     var listener = Components.classes["@mozilla.org/network/simple-stream-listener;1"];
//     if(!listener) {
// 	clamdOutStream.close();
// 	return false;
//     }
//     listener = listener.createInstance(Components.interfaces.nsISimpleStreamListener);
//     if(!listener) {
// 	clamdOutStream.close();
// 	return false;
//     }
//     listener.init(clamdOutStream, observer);
	
//     /* a pump for async reads from the msgInStream */
//     var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"];
//     if(!pump) {
// 	clamdOutStream.close();
// 	return false;
//     }
//     pump = pump.createInstance(Components.interfaces.nsIInputStreamPump);
//     if(!pump) {
// 	clamdOutStream.close();
// 	return false;
//     }
//     pump.init(msgInStream, -1, -1, 0, 0, false);
	
//     /* pump! */
//     pump.asyncRead(listener, null);
//     return true;
// }


function clamdStreamMsg(msgInStream, chost, strport, caller) {
    /* create a socket transport interface */
    var transportSvc = Components.classes["@mozilla.org/network/socket-transport-service;1"];
    if (!transportSvc) return false;
    transportSvc = transportSvc.getService(Components.interfaces.nsISocketTransportService);
    if (!transportSvc) return false;

    dump("Attempting to connect to clamd at " + chost + ":" + strport + " for streaming...\n");
    try {
	/* get the transport service */
	var clamdTrans = transportSvc.createTransport(null,0,chost,strport,null);
    } catch (ex) {
	dump("falied to create transport: " + ex + "\n");
	return false;
    }
    if(!clamdTrans) return false;

    /* where to write to */
    var clamdOutStream = clamdTrans.openOutputStream(0,0,0);
    if(!clamdOutStream) return false;

    /* a listener for the pump doing async writes each time the pump pumps data */
    var listener = {
	onStartRequest: function (request, context) {
	    dump("Streaming to clamd initiated...\n");
	},
	onStopRequest: function (request, context, statusCode) {
	    dump("Streaming to clamd completed with " + statusCode + "\n");
	    if (statusCode) caller.abortScan();
	    clamdOutStream.close();
	},
	onDataAvailable: function (request, context, inputStream, offset, count) {
 	    /* need something readable AND scriptable */
 	    var inStreamJs = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
 	    inStreamJs.init(inputStream);

	    var msgData = inStreamJs.read(count);
	    while(count) {
		try {
		    count -= clamdOutStream.write(msgData, count);
		} catch (ex) {
		    /* need to trap block errors and spinwait - there's no sleep() */
		    if (ex.result != Components.results.NS_BASE_STREAM_WOULD_BLOCK) break;
		}
	    }
	    /* FIXME closing inStreamJs would also close msgInStream - guess i'll have to rely on the GC */
	}
    };

    /* a pump for async reads from the msgInStream */
    var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"];
    if(!pump) {
	clamdOutStream.close();
	return false;
    }
    pump = pump.createInstance(Components.interfaces.nsIInputStreamPump);
    if(!pump) {
	clamdOutStream.close();
	return false;
    }
    pump.init(msgInStream, -1, -1, 0, 0, false);
	
    /* pump! */
    pump.asyncRead(listener, null);
    return true;
}
	    

function virusscan () {
    /* get the selected message - works on the message list AND in the message window */
    if (gFolderDisplay.selectedCount == 0) return;
    var msgURI = gFolderDisplay.selectedMessageUris[0];
    /* get the correct service for the URI - we need the streamMessage method */
    var msgSvc = messenger.messageServiceFromURI(msgURI);
    /* create and instance of a stream listener to be used as a consumer for msgSvc streamMessage method */
    var msgStream = Components.classes["@mozilla.org/network/sync-stream-listener;1"].createInstance();
    /* retrieve the nsIInputStream associated with the listener */
    var msgInStream = msgStream.QueryInterface(Components.interfaces.nsIInputStream);

    /* tell the luser what we're doing */
    setVirusLabel(msgURI, _('status.scanning'), 'grey');
    
    /* we associate the stream listener as a consumer for the streamMesaage method */
    try {
	msgSvc.streamMessage(msgURI, msgStream, msgWindow, null, false, null);
    } catch (ex) {
	setVirusLabel(msgURI, _('status.exception') + ': ' + ex, 'orange');
	return;
    }

    /* If we REALLY have a message */
    if(msgInStream.available()) {
	/* create a socket service */
	var transportSvc = Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);

	/* get prefs */
	var prefs = getPrefs();
	var chost = prefs.getCharPref('host');
	var cport = prefs.getIntPref('port');
	var timeout = 1000 * prefs.getIntPref('timeout');
	var deny = (prefs.getIntPref('action') == 1);

	dump("Connecting to clamd at " + chost + ":" + cport + "...\n");
	/* create a socket transport */
	try {
	    var clamdTrans = transportSvc.createTransport(null,0,chost,cport,null);
	} catch (ex) {
	    dump("Falied to create transport: " + ex + "\n");
	    setVirusLabel(msgURI, _('status.exception') + ': ' + ex, 'orange');
	    msgInStream.close();	    
	    return;
	}

	dump("Connected to clamd (" + clamdTrans.host + ":" + clamdTrans.port + ")\n");

	/* create an output and an input stream to clamd main port */
	/* since nsIInputStream.read() is NOT SCRIPTABLE we additionally need a scriptable input stream */
	var clamdOutStream = clamdTrans.openOutputStream(0,0,0);
        var clamdInStream = clamdTrans.openInputStream(0,0,0);
	var clamdInStreamJs = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
	clamdInStreamJs.init(clamdInStream);

	/* send request and clean the write side of the pipe */
	clamdOutStream.write("STREAM\n", 7);
	clamdOutStream.close();

	/* a listener for the pump for async reading */
	var listener = {
	    phase : 0, /* phase0 = read the port to stream to - phase1 = read the scan results - phase2 = error/timeout */
	    reply : "",
	    tid : null,
	    onStartRequest: function (request, context){},
	    onStopRequest: function (request, context, statusCode) {
		window.clearTimeout(this.tid);
		/* we land here when the conn is broken */
		dump("listener_stop: stopped with " + statusCode + "\n");
		if (this.phase == 1) {
		    /* if we're in phase 1, all good, we parse the reply  and update the label accordingly */
		    dump("CLAMD reply: " + this.reply);
		    var res = this.reply.replace(/^.*: (.*)\n/, '$1');
		    if (res == 'OK') {
			setVirusLabel(msgURI, _('status.clean'), 'green');
		    } else if (res.match(/ FOUND$/)) {
			setVirusLabel(msgURI, _('status.infected') + ' (' + res.replace(/ FOUND$/,'') + ')', 'red');
			if (deny && msgURI == gFolderDisplay.selectedMessageUris[0]) {
			    /* additionally if we are required to block access we lame out the content and we close the attachment panel */
			    document.getElementById('messagepane').contentDocument.firstChild.innerHTML=_('status.replacedcontent');
			    document.getElementById('attachmentView').collapsed = true;
			}
		    } else {
			setVirusLabel(msgURI, _('status.unknown') + ' (' + res + ')', 'orange');
		    }
		} else if (this.phase == 0) {
		    setVirusLabel(msgURI, _('status.connfail'), 'orange');
		} else {
		    setVirusLabel(msgURI, _('status.timedout'), 'orange');
		}

		/* cleanup */
		clamdInStreamJs.close();
		clamdInStream.close();
		msgInStream.close();
	    },
	    onDataAvailable: function (request, context, inputStream, offset, count) {
		/* we land here when we've got something to read */
		try {
		    this.reply += clamdInStreamJs.read(count);
		    if (this.phase == 0 && this.reply.match(/^PORT ([0-9]+)\n/)) {
			/* in phase0 we collect the stream port */
			var strport = parseInt(this.reply.replace(/^PORT ([0-9]+)/, '$1'));
			dump("listener_data: got clamd stream port - " + strport + "\n");
			this.reply = '';
			this.phase = 1;
			if(!clamdStreamMsg(msgInStream, chost, strport, this)) this.abortScan();
		    }
		} catch (ex) {
		    alert(ex);
		}
	    },
	    abortScan: function () {
		dump("aborting scan request\n");
		this.phase = 2;
		clamdInStreamJs.close();
		clamdInStream.close();
	    }
	};

	listener.tid = window.setTimeout(function(e) {listener.abortScan();}, timeout);

	/* a pump for async reading from clamd main socket */
	var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
	pump.init(clamdInStream, -1, -1, 0, 0, false);
	pump.asyncRead(listener, null);

    } else {
	/* if we land here the message has no available content, whatever the reason */
	alert("WTF?!");
	msgInStream.close();
    }
}

function setstatus() {
    var prefs = getPrefs();
    var vp = document.getElementById('clamdrib-pane');
    var st = document.getElementById('clamdrib-status-bar');
    var br = document.getElementById('messagepane');
    if (prefs.getBoolPref('enabled')) {
	st.setAttribute('label', _('label.enabled'));
	vp.collapsed = false;
	br.addEventListener('load', virusscan, true);
	virusscan();
    } else {
	st.setAttribute('label', _('label.disabled'));
	vp.collapsed = true;
	br.removeEventListener('load', virusscan, true);
    }
}

function switchStatus() {
    var prefs = getPrefs();
    prefs.setBoolPref('enabled', !prefs.getBoolPref('enabled'));
}

var StatusMonitor = {
    prefs : null,
    start: function() {
	this.prefs = getPrefs();
	this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
	this.prefs.addObserver("", this, false);
	setstatus();
    },

    stop: function()  {
	this.prefs.removeObserver("", this);
    },

    observe: function(subject, topic, data) {
	if (topic == "nsPref:changed" || data == 'enabled') setstatus();
    }
};
  
window.addEventListener("load", function (e) {StatusMonitor.start();}, false);
window.addEventListener("unload", function (e) {StatusMonitor.stop();}, false);

