function updateUI() {
    var prefs = getPrefs();
    document.getElementById('clamdrib-enabled').checked = prefs.getBoolPref('enabled');
    document.getElementById('clamdrib-host').value = prefs.getCharPref('host');
    document.getElementById('clamdrib-port').value = prefs.getIntPref('port');
    document.getElementById('clamdrib-timeout').value = prefs.getIntPref('timeout');
    document.getElementById('clamdrib-action').selectedIndex = prefs.getIntPref('action');
}

function loaded() {
    updateUI();
    window.sizeToContent();
}

function checkSettings() {
    var host = document.getElementById('clamdrib-host').value;
    var port = document.getElementById('clamdrib-port').value;
    var timeout = document.getElementById('clamdrib-timeout').value;
    var action = document.getElementById('clamdrib-action').selectedIndex;
    if (host == '' || isNaN(parseInt(port)) || port <1 || port>65535 || isNaN(parseInt(timeout)) || timeout<1 || timeout>120 || isNaN(parseInt(action)) || action<0) {
	alert(_(options.incorrect));
	return false;
    }
    return true;
}

function testConn() {
    if (!checkSettings()) return;
    var host = document.getElementById('clamdrib-host').value;
    var port = document.getElementById('clamdrib-port').value;
    var stype=new Array('tcp');
    var transportSvc = Components.classes["@mozilla.org/network/socket-transport-service;1"].getService(Components.interfaces.nsISocketTransportService);
    var clamdTrans = transportSvc.createTransport(stype,0,host,port,null);

    var clamdOutStream = clamdTrans.openOutputStream(0,0,0);
    clamdOutStream.write("VERSION\n", 8);

    var clamdInStream = clamdTrans.openInputStream(0,0,0);
    var clamdInStreamJs = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
    var listener = {
	reply : "",
	onStartRequest: function(request, context){},
	onStopRequest: function(request, context, status) {
	    if(this.reply) alert(_('options.success') + ' ' + this.reply);
	    else alert(_('options.failed'));
	},
	onDataAvailable: function(request, context, inStream, offset, count) {
	    this.reply += clamdInStreamJs.read(count);
	},
    };
    clamdInStreamJs.init(clamdInStream);
    var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"].createInstance(Components.interfaces.nsIInputStreamPump);
    pump.init(clamdInStream, -1, -1, 0, 0, false);
    pump.asyncRead(listener,null);
}

function savePrefs() {
    if (!checkSettings()) return false;
    var prefs = getPrefs();
    prefs.setBoolPref('enabled', document.getElementById('clamdrib-enabled').checked);
    prefs.setCharPref('host', document.getElementById('clamdrib-host').value);
    prefs.setIntPref('port', document.getElementById('clamdrib-port').value);
    prefs.setIntPref('timeout', document.getElementById('clamdrib-timeout').value);
    prefs.setIntPref('action', document.getElementById('clamdrib-action').selectedIndex);
    return true;
}

